use strict;

# - ,  -  
my %CODES;	
# - ,  -   
my %ZONES;

#process_file( "8.csv", "7" );
#TODO:    
process_file( "tarif-00.csv" );

#   
open CODES_FILE, ">result\\codes.txt"
	or die "Can't open result\\codes.txt on write!\n";

foreach my $key( sort( keys %CODES ) )
{
	print CODES_FILE "$key\t$CODES{$key}\n";
}

close CODES_FILE;

#  
open ZONE_MAP, ">result\\zone_map.xml"
	or die "Can't open result\\zone_map.xml on write!\n";
	
print ZONE_MAP "<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n";
print ZONE_MAP "<zones>\n";
	
foreach my $key( sort( keys %ZONES )  )	
{
	print ZONE_MAP "\t<zone name=\"$key\">\n";
	print ZONE_MAP "\t\t<codes>\n";

	foreach my $code( sort( split( ",", $ZONES{$key} ) ) )
	{
		print ZONE_MAP "\t\t\t<code id=\"$code\"/>\n";
	}
	
	print ZONE_MAP "\t\t</codes>\n";
	print ZONE_MAP "\t</zone>\n";
}
	
print ZONE_MAP "</zones>\n";
close ZONE_MAP;	

#TODO:         
#      
create_tariff( "jur" );
create_tariff( "phis" );

#    
sub create_tariff
{
	my $file_name = shift;
	
	open FILE, ">result\\$file_name.xml"
		or die "Can't open result\\$file_name.xml on write!\n";
	
	print FILE "<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n";
	print FILE "<nodes>\n";
	print FILE "\t<use_map id=\"1\" title=\" \"/>\n";
	print FILE "\t<config data=\"0;5;0:0:60\"/>\n";
		
	foreach my $key( sort( keys %ZONES ) )
	{
		print FILE "\t<zone zone=\"$key\">\n";
	
		my $prefix = substr( $key, 0, 1 );		
		my @prices = split( ";", substr( $key, 1 ) );
		
		my $price1 = undef; 
		my $price2 = undef;
		
		#TODO:      
		if( $file_name eq "jur" )
		{
			$price1 = $prices[0];
			$price2 = $prices[1];
		}
		elsif( $file_name eq "phis" )
		{
			$price1 = $prices[2];
			$price2 = $prices[3];
		}
		
		my $sid = 14;
		if( $prefix eq "W" )
		{
			$sid = 15;
		}
		elsif ( $prefix eq "Z" )
		{
			$sid = 19;
		}
		
		
		print FILE "\t\t<service_set regexp=\"^8\" sid=\"$sid\"/>\n";
		
		print FILE "\t\t<time_filter id=\"2\" title=\"  \">\n";
        print FILE "\t\t\t<costout default=\"true\" value=\"$price2\"/>\n";
        print FILE "\t\t</time_filter>\n";
      	print FILE "\t\t<time_filter id=\"1\" title=\" \">\n";
       	print FILE "\t\t\t<costout default=\"true\" value=\"$price1\"/>\n";
        print FILE "\t\t</time_filter>\n";
			
		print FILE "\t</zone>\n"
	}	
	
	     
	print FILE "</nodes>\n";
	close FILE;
}

#     
sub process_file
{
	my $file_name = shift;
	my $add_prefix = shift;
	
	open FILE, "<$file_name"
		or die "Can't open file $file_name\n";

    while(<FILE>)
    {
       # , ;3433;4,88;4,88;4,14;2,88
       #TODO: regexp 
       if( m#^(.+);(\d+);([\d\,]+;[\d\,]+;[\d\,]+;[\d\,]+);(.+)$# )
       {
			my $dest_title = $1;
      		my $code = $2;
      		my $prices = $3;
      		my $type = $4;
      		
      		$prices =~ s#\,#\.#g;
      		#TODO:   
      		if( $type eq " " )
      		{
      			$prices = "W$prices";
      		}
      		elsif( $type eq " " )
      		{
      			$prices = "Z$prices";
      		}
    		elsif( $type eq " " )
    		{
	   			$prices = "R$prices";
    		}
    		else
    		{
    			print "ERROR type ".$type."\n";
    		}
       	
       		$CODES{$code} = $dest_title;
       		
       		if( $ZONES{$prices} )
       		{
       			$ZONES{$prices} = "$ZONES{$prices},$code";
       		}
       		else
       		{
       			$ZONES{$prices} = $code;
       		}
       	}	
    }
    
    close FILE;
}	

